<?php
// Read the posted JSON body
$json = file_get_contents('php://input');

// Paste here the Dialog Insight public key, in PEM format.
$cert = "-----BEGIN PUBLIC KEY-----
MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQC+G9hY+unSyd5vSzPdClp8d6hc
5TxvVyFX4sz7jTlLuZPcHQbAiu2kX0xsmYqOF8/cDOpR9R40L9ZggOplm9zDBwF8
Qc/T3b2grB/SSl0l/eOl6HcPlGsoGOrQTyXQ9ZArmnXdbhgMocSODowcc6xWsorn
XWpUXlJRCPq6waI8gwIDAQAB
-----END PUBLIC KEY-----";

// Retrieve and decode the "X-DI-Signature" HTTP header
$headers =  getallheaders();
$signature = null;
foreach($headers as $key=>$val) {
	if (strtolower($key) == 'x-di-signature') {
		$signature = base64_decode($val);
	}
}

// Verify the signature
$ok = openssl_verify($json, $signature, $cert, OPENSSL_ALGO_SHA256);
if ($ok == 1) {
    // Do not process event contents here : queue the event to be processed asychronously.
	// Example: dumping to a file
	$myfile = file_put_contents('C:\\Temp\\webhook-event-' . uniqid('', true) . '.json', $json);
	echo "OK";
} else {
    // TODO: Error handling, signature validation failed
	echo "ERROR";
}
?>
